// Copyright (c) 2017 M.Hirsch
// Please see LICENSE.txt for license

#ifndef GLOBAL_H_
#define GLOBAL_H_

#define F_CPU	4000000UL

#define ssda_dir			DDRB
#define ssda_pin			PINB
#define ssda_bit			bit0
#define ssda_port			PORTB

#define sscl_dir			DDRB
#define sscl_pin			PINB
#define sscl_bit			bit1
#define sscl_port			PORTB

#define ssda_hi			bitclr(ssda_dir, ssda_bit)
#define ssda_lo			bitset(ssda_dir, ssda_bit)
#define sscl_hi			bitclr(sscl_dir, sscl_bit)
#define sscl_lo			bitset(sscl_dir, sscl_bit)
#define ssda_tst		(ssda_pin & ssda_bit) ? 1 : 0
#define sscl_tst		(sscl_pin & sscl_bit) ? 0 : 1

#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include <stdlib.h>
#include <avr/pgmspace.h>

#define bitc	0x00
#define bit0	0x01
#define bit1	0x02
#define bit2	0x04
#define bit3	0x08
#define bit4	0x10
#define bit5	0x20
#define bit6	0x40
#define bit7	0x80
#define bit8	0x0100
#define bit9	0x0200
#define bit10	0x0400
#define bit11	0x0800
#define bit12	0x1000
#define bit13	0x2000
#define bit14	0x4000
#define bit15	0x8000

#define bitset(r, b)		((r) |= (b))
#define bitclr(r, b)		((r) &= ~(b))
#define bitout(r, b)		((r) = (b))
#define bittog(r, b)		((r) ^= (b))
#define bitdef(r, m, b)		bitclr(r, m); bitset(r, b)
#define bittst(r, b)		(((r) & (b)) ? 1 : 0)
#define bittsti(r, b)		(((r) & (b)) ? 0 : 1)
#define bitntst(r, m, b)	((((r) & (m)) == (b)) ? 1 : 0)
#define bitntsti(r, m, b)	((((r) & (m)) == (b)) ? 0 : 1)

#include "ports.h"
#include "i2c.h"
#include "oled.h"

#endif /* GLOBAL_H_ */