// Copyright (c) 2017 M.Hirsch
// Please see LICENSE.txt for license

#ifndef I2C_H_
#define I2C_H_

#include "global.h"

#define sda_dir			DDRA
#define sda_pin			PINA
#define sda_bit			bit0
#define sda_port		PORTA

#define scl_dir			DDRA
#define scl_pin			PINA
#define scl_bit			bit1
#define scl_port		PORTA

#define i2c_wait_val	2

#define SUCCESS			0
#define FAIL			!SUCCESS
#define READ			1
#define WRITE			0
#define ACK				1
#define NACK			0

#define sda_hi			bitclr(sda_dir, sda_bit)
#define sda_lo			bitset(sda_dir, sda_bit)
#define scl_hi			bitclr(scl_dir, scl_bit)
#define scl_lo			bitset(scl_dir, scl_bit)
#define sda_tst			(sda_pin & sda_bit) ? 1 : 0
#define scl_tst			(scl_pin & scl_bit) ? 0 : 1

void init_i2c(void);
void i2c_wait(void);
void i2c_wait_clk(void);
void i2c_start();
void i2c_stop();
uint8_t i2c_write(uint8_t val);
uint8_t i2c_read(uint8_t ack);
uint8_t i2c_start_adr(uint8_t adr, uint8_t RW);

#endif /* I2C_H_ */