// Copyright (c) 2017 M.Hirsch
// Please see LICENSE.txt for license

#include "global.h"

int main(void)
{
	bool adr[128] = {0};
	uint8_t val, m, da, a, nx, fill, fillcn, cn;

	OSCCAL = 0xFF;
	init_i2c();
	init_oled();

	bitclr(ssda_port, sda_bit);
	bitclr(ssda_port, scl_bit);
	ssda_hi;
	sscl_hi;
 
 	while (1)
	{
		for(cn = 0; cn < 128; cn++)
		{
			ssda_lo;
			i2c_wait();
			sscl_lo;
			i2c_wait();
			i2c_wait();
			val = cn<<1;
			m = 0x80;
			while(m)
			{
				if(val & m)
					ssda_hi;
				else
					ssda_lo;
				i2c_wait_clk();
				sscl_hi;
				i2c_wait_clk();
				m >>= 1;
				sscl_lo;
			}
			m = SUCCESS;
			i2c_wait_clk();
			ssda_hi;
			i2c_wait_clk();
			sscl_hi;
			i2c_wait_clk();
			if(ssda_tst) m = FAIL;
			sscl_lo;
			i2c_wait();
			if(m == SUCCESS) adr[cn] = 1;
			else adr[cn] = 0;
			ssda_lo;
			i2c_wait();
			sscl_hi;
			i2c_wait();
			ssda_hi;
			i2c_wait();
			_delay_ms(5);
		}
		oled_xy(0, 0);
		da = 0;
		a = 0;
		nx = 17;
		fill = 0;
		fillcn = 4;
		i2c_start();
		i2c_write(0x78);
		i2c_write(0x40);
		for(uint16_t y = 0; y < 8; y++)
		{
			nx = 17;
			for(uint16_t x = 0; x < 128; x++)
			{
				da = rb(&frame[x+(y*128)]);
				if((x == nx) && (y > 0))
				{
					a = (((nx-17) / 7)<<3)+y;
					nx = nx+7;
					fillcn = 4;
					if(y == 1)
					{
						if(adr[a-1])		fill = 0b00011110;
					}else if(y == 2){
						if(adr[a-1])		fill = 0b00001111;
						if(adr[a])			fill = 0b10000000;
					}else if(y == 3){
						if(adr[a-1])		fill = 0b00000111;
						if(adr[a])			fill = 0b11000000;
					}else if(y == 4){
						if(adr[a-1])		fill = 0b00000011;
						if(adr[a])			fill = 0b11100000;
					}else if(y == 5){
						if(adr[a-1])		fill = 0b00000001;
						if(adr[a])			fill = 0b11110000;
					}else if(y == 6){
						if(adr[a])			fill = 0b01111000;
					}else if(y == 7){
						if(adr[a])			fill = 0b00111100;
					}else{
						fillcn = 0;
					}
				}
				if(fillcn)
				{
					 da |= fill;
					 fillcn--;
				}else{
					fill = 0;
				}
				i2c_write(da);
			}
		}
		i2c_stop();
	}
	_delay_ms(500);
}

